/*!
* @file ItemEgo.h
* @brief ゲーム中のアイテムエゴのプロトタイプ
* @date 2014/02/01
* @author Deskull
* 2014 Sikabane Works.
*/

#include "stdafx.h"
#include "Dice.h"
#include "GameElement.h"
#include "ItemTemplate.h"
#include "SavingTable.h"

BOOST_CLASS_VERSION(ItemEgo, 1);

namespace Deeangband 
{

	/*! 
	* @class ItemEgo
	* @brief アイテムエゴのクラス
	*/
	class ItemEgo : public ItemTemplate
	{

	private:

		std::string name; //!< エゴの銘
		Dice plusDamage; //!< ベースダメージのダイス加算修正
		WEIGHT weight; //!< アイテムの重量加算修正
		SavingTable baseSaving; //!< 基本セービング修正
		SavingTable plusSaving; //!< 追加セービング修正

		friend class boost::serialization::access;
		template<class Archive> void serialize(Archive &archive, const unsigned int) 
		{
			archive & BOOST_SERIALIZATION_NVP(name);
			archive & BOOST_SERIALIZATION_NVP(baseDamage);
			archive & BOOST_SERIALIZATION_NVP(weight);
			archive & BOOST_SERIALIZATION_NVP(baseSaving);
			archive & BOOST_SERIALIZATION_NVP(plusSaving);
		}


	public:

		/*! 
		* @brief ItemEgoクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		ItemEgo::ItemEgo(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief ItemEgoクラスコンストラクタ
		*/
		ItemEgo::ItemEgo(void);

		/*! 
		* @brief ItemEgoクラスデストラクタ
		*/
		ItemEgo::~ItemEgo(void);

		/*! 
		* @brief ダメージダイス修正を返す
		* @return ダメージダイス修正
		*/
		Dice ItemEgo::GetPlusDamageDice(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void ItemEgo::SetDammyData(void);

	};

}